diff --git a/libinterp/octave-value/ov-base-diag.cc b/libinterp/octave-value/ov-base-diag.cc
index f300304..6bf6bfe 100644
--- a/libinterp/octave-value/ov-base-diag.cc
+++ b/libinterp/octave-value/ov-base-diag.cc
@@ -29,6 +29,7 @@ along with Octave; see the file COPYING.  If not, see
 #include "mach-info.h"
 #include "lo-ieee.h"
 
+#include "ov-base-diag.h"
 #include "mxarray.h"
 #include "ov-base.h"
 #include "ov-base-mat.h"
@@ -103,26 +104,36 @@ octave_base_diag<DMT, MT>::do_index_op (const octave_value_list& idx,
 
   if (idx.length () == 2 && ! resize_ok)
     {
-      idx_vector idx0 = idx(0).index_vector ();
-      idx_vector idx1 = idx(1).index_vector ();
-
-      if (idx0.is_scalar () && idx1.is_scalar ())
-        {
-          retval = matrix.checkelem (idx0(0), idx1(0));
-        }
-      else
+      int k = 0;        // index we're accesing when index_vector throws
+      try
         {
-          octave_idx_type m = idx0.length (matrix.rows ());
-          octave_idx_type n = idx1.length (matrix.columns ());
-          if (idx0.is_colon_equiv (m) && idx1.is_colon_equiv (n)
-              && m <= matrix.rows () && n <= matrix.rows ())
+          idx_vector idx0 = idx(0).index_vector ();
+          k = 1;
+          idx_vector idx1 = idx(1).index_vector ();
+
+          if (idx0.is_scalar () && idx1.is_scalar ())
             {
-              DMT rm (matrix);
-              rm.resize (m, n);
-              retval = rm;
+              retval = matrix.checkelem (idx0(0), idx1(0));
             }
           else
-            retval = to_dense ().do_index_op (idx, resize_ok);
+            {
+              octave_idx_type m = idx0.length (matrix.rows ());
+              octave_idx_type n = idx1.length (matrix.columns ());
+              if (idx0.is_colon_equiv (m) && idx1.is_colon_equiv (n)
+                  && m <= matrix.rows () && n <= matrix.rows ())
+                {
+                  DMT rm (matrix);
+                  rm.resize (m, n);
+                  retval = rm;
+                }
+              else
+                retval = to_dense ().do_index_op (idx, resize_ok);
+            }
+        }
+      catch (idx_except& e)
+        {
+          e.set_pos_if_unset (2, k+1);
+          throw;   // caught in pt-idx.cc / pt-assign.cc to get var name
         }
     }
   else
@@ -153,17 +164,27 @@ octave_base_diag<DMT, MT>::subsasgn (const std::string& type,
                 && jdx(0).is_scalar_type () && jdx(1).is_scalar_type ())
               {
                 typename DMT::element_type val;
-                idx_vector i0 = jdx(0).index_vector ();
-                idx_vector i1 = jdx(1).index_vector ();
-                if (! error_state  && i0(0) == i1(0)
-                    && i0(0) < matrix.rows () && i1(0) < matrix.cols ()
-                    && chk_valid_scalar (rhs, val))
+                int k = 0;
+                try
+                  {
+                    idx_vector i0 = jdx(0).index_vector ();
+                    k = 1;
+                    idx_vector i1 = jdx(1).index_vector ();
+                    if (! error_state  && i0(0) == i1(0)
+                        && i0(0) < matrix.rows () && i1(0) < matrix.cols ()
+                        && chk_valid_scalar (rhs, val))
+                      {
+                        matrix.dgelem (i0(0)) = val;
+                        retval = this;
+                        this->count++;
+                        // invalidate cache
+                        dense_cache = octave_value ();
+                      }
+                  }
+                catch (idx_except& e)
                   {
-                    matrix.dgelem (i0(0)) = val;
-                    retval = this;
-                    this->count++;
-                    // invalidate cache
-                    dense_cache = octave_value ();
+                    e.set_pos_if_unset (2, k+1);
+                    throw; // caught in pt-idx.cc / pt-assign.cc to get var name
                   }
               }
 
diff --git a/libinterp/octave-value/ov-base-mat.cc b/libinterp/octave-value/ov-base-mat.cc
index 9b0bcff..aad899f 100644
--- a/libinterp/octave-value/ov-base-mat.cc
+++ b/libinterp/octave-value/ov-base-mat.cc
@@ -36,7 +36,7 @@ along with Octave; see the file COPYING.  If not, see
 #include "ov-base-mat.h"
 #include "ov-base-scalar.h"
 #include "pr-output.h"
-
+ 
 template <class MT>
 octave_value
 octave_base_matrix<MT>::subsref (const std::string& type,
@@ -140,72 +140,86 @@ octave_base_matrix<MT>::do_index_op (const octave_value_list& idx,
   int nd = matrix.ndims ();
   const MT& cmatrix = matrix;
 
-  switch (n_idx)
-    {
-    case 0:
-      retval = matrix;
-      break;
-
-    case 1:
-      {
-        idx_vector i = idx (0).index_vector ();
-
-        if (! error_state)
-          {
-            // optimize single scalar index.
-            if (! resize_ok && i.is_scalar ())
-              retval = cmatrix.checkelem (i(0));
-            else
-              retval = MT (matrix.index (i, resize_ok));
-          }
-      }
-      break;
-
-    case 2:
-      {
-        idx_vector i = idx (0).index_vector ();
-
-        if (! error_state)
-          {
-            idx_vector j = idx (1).index_vector ();
-
-            if (! error_state)
-              {
-                // optimize two scalar indices.
-                if (! resize_ok && i.is_scalar () && j.is_scalar ())
-                  retval = cmatrix.checkelem (i(0), j(0));
-                else
-                  retval = MT (matrix.index (i, j, resize_ok));
-              }
-          }
-      }
-      break;
-
-    default:
-      {
-        Array<idx_vector> idx_vec (dim_vector (n_idx, 1));
-        bool scalar_opt = n_idx == nd && ! resize_ok;
-        const dim_vector dv = matrix.dims ();
-
-        for (octave_idx_type i = 0; i < n_idx; i++)
-          {
-            idx_vec(i) = idx(i).index_vector ();
-
-            if (error_state)
-              break;
-
-            scalar_opt = (scalar_opt && idx_vec(i).is_scalar ());
-          }
+    // If we catch an indexing error in  index_vector(),  we flag an error in
+    // index  k.  Ensure it is the right value befor each idx_vector() call.
+    // Same variable as used in for() loop in default: case.
+  octave_idx_type k = 0;
 
-        if (! error_state)
-          {
-            if (scalar_opt)
-              retval = cmatrix.checkelem (conv_to_int_array (idx_vec));
-            else
-              retval = MT (matrix.index (idx_vec, resize_ok));
-          }
-      }
-      break;
+  try
+    {
+      switch (n_idx)
+	{
+	case 0:
+	  retval = matrix;
+	  break;
+
+	case 1:
+	  {
+	    idx_vector i = idx (0).index_vector ();
+
+	    if (! error_state)
+	      {
+		// optimize single scalar index.
+		if (! resize_ok && i.is_scalar ())
+		  retval = cmatrix.checkelem (i(0));
+		else
+		  retval = MT (matrix.index (i, resize_ok));
+	      }
+	  }
+	  break;
+
+	case 2:
+	  {
+	    idx_vector i = idx (0).index_vector ();
+
+	    if (! error_state)
+	      {
+		k=1;
+		idx_vector j = idx (1).index_vector ();
+
+		if (! error_state)
+		  {
+		    // optimize two scalar indices.
+		    if (! resize_ok && i.is_scalar () && j.is_scalar ())
+		      retval = cmatrix.checkelem (i(0), j(0));
+		    else
+		      retval = MT (matrix.index (i, j, resize_ok));
+		  }
+	      }
+	  }
+	  break;
+
+	default:
+	  {
+	    Array<idx_vector> idx_vec (dim_vector (n_idx, 1));
+	    bool scalar_opt = n_idx == nd && ! resize_ok;
+	    const dim_vector dv = matrix.dims ();
+
+	    for (k = 0; k < n_idx; k++)
+	      {
+		idx_vec(k) = idx(k).index_vector ();
+
+		if (error_state)
+		  break;
+
+		scalar_opt = (scalar_opt && idx_vec(k).is_scalar ());
+	      }
+
+	    if (! error_state)
+	      {
+		if (scalar_opt)
+		  retval = cmatrix.checkelem (conv_to_int_array (idx_vec));
+		else
+		  retval = MT (matrix.index (idx_vec, resize_ok));
+	      }
+	  }
+	  break;
+	}
+    }
+  catch (idx_except& e)
+    {
+      e.set_pos_if_unset (n_idx, k+1);
+      throw;   // to be caught in pt-idx.cc / pt-assign.cc, when var name known
     }
 
   return retval;
@@ -217,51 +231,64 @@ octave_base_matrix<MT>::assign (const octave_value_list& idx, const MT& rhs)
 {
   octave_idx_type n_idx = idx.length ();
 
-  switch (n_idx)
-    {
-    case 0:
-      panic_impossible ();
-      break;
-
-    case 1:
-      {
-        idx_vector i = idx (0).index_vector ();
-
-        if (! error_state)
-          matrix.assign (i, rhs);
-      }
-      break;
-
-    case 2:
-      {
-        idx_vector i = idx (0).index_vector ();
-
-        if (! error_state)
-          {
-            idx_vector j = idx (1).index_vector ();
-
-            if (! error_state)
-              matrix.assign (i, j, rhs);
-          }
-      }
-      break;
-
-    default:
-      {
-        Array<idx_vector> idx_vec (dim_vector (n_idx, 1));
+    // If we catch an indexing error in  index_vector(),  we flag an error in
+    // index  k.  Ensure it is the right value befor each idx_vector() call.
+    // Same variable as used in for() loop in default: case.
+  octave_idx_type k = 0;
 
-        for (octave_idx_type i = 0; i < n_idx; i++)
-          {
-            idx_vec(i) = idx(i).index_vector ();
-
-            if (error_state)
-              break;
-          }
-
-        if (! error_state)
-          matrix.assign (idx_vec, rhs);
-      }
-      break;
+  try
+    {
+      switch (n_idx)
+	{
+	  case 0:
+	    panic_impossible ();
+	    break;
+
+	  case 1:
+	    {
+		  idx_vector i = idx (0).index_vector ();
+
+		  if (! error_state)
+		    matrix.assign (i, rhs);
+	    }
+	    break;
+
+	  case 2:
+	    {
+	      idx_vector i = idx (0).index_vector ();
+
+	      if (! error_state)
+		{
+		  k = 1;
+		  idx_vector j = idx (1).index_vector ();
+
+		  if (! error_state)
+		    matrix.assign (i, j, rhs);
+		}
+	    }
+	    break;
+
+	  default:
+	    {
+	      Array<idx_vector> idx_vec (dim_vector (n_idx, 1));
+
+	      for (k = 0; k < n_idx; k++)
+		{
+		  idx_vec(k) = idx(k).index_vector ();
+
+		  if (error_state)
+		    break;
+		}
+
+	      if (! error_state)
+		matrix.assign (idx_vec, rhs);
+	    }
+	    break;
+	}
+    }
+  catch (idx_except& e)
+    {
+      gripe_invalid_index (e.idx(), n_idx, k+1);
     }
 
   // Clear cache.
@@ -284,89 +311,102 @@ octave_base_matrix<MT>::assign (const octave_value_list& idx,
 {
   octave_idx_type n_idx = idx.length ();
 
+    // If we catch an indexing error in  index_vector(),  we flag an error in
+    // index  k.  Ensure it is the right value befor each idx_vector() call.
+    // Same variable as used in for() loop in default: case.
+  octave_idx_type k = 0;
+
   int nd = matrix.ndims ();
 
   MT mrhs (dim_vector (1, 1), rhs);
 
-  switch (n_idx)
+  try
     {
-    case 0:
-      panic_impossible ();
-      break;
-
-    case 1:
-      {
-        idx_vector i = idx (0).index_vector ();
-
-        if (! error_state)
-          {
-            // optimize single scalar index.
-            if (i.is_scalar () && i(0) < matrix.numel ())
-              matrix(i(0)) = rhs;
-            else
-              matrix.assign (i, mrhs);
-          }
-      }
-      break;
-
-    case 2:
-      {
-        idx_vector i = idx (0).index_vector ();
-
-        if (! error_state)
-          {
-            idx_vector j = idx (1).index_vector ();
-
-            if (! error_state)
-              {
-                // optimize two scalar indices.
-                if (i.is_scalar () && j.is_scalar () && nd == 2
-                    && i(0) < matrix.rows () && j(0) < matrix.columns ())
-                  matrix(i(0), j(0)) = rhs;
-                else
-                  matrix.assign (i, j, mrhs);
-              }
-          }
-      }
-      break;
-
-    default:
-      {
-        Array<idx_vector> idx_vec (dim_vector (n_idx, 1));
-        bool scalar_opt = n_idx == nd;
-        const dim_vector dv = matrix.dims ().redim (n_idx);
-
-        for (octave_idx_type i = 0; i < n_idx; i++)
-          {
-            idx_vec(i) = idx(i).index_vector ();
-
-            if (error_state)
-              break;
-
-            scalar_opt = (scalar_opt && idx_vec(i).is_scalar ()
-                          && idx_vec(i)(0) < dv(i));
-          }
-
-        if (! error_state)
-          {
-            if (scalar_opt)
-              {
-                // optimize all scalar indices. Don't construct an index array,
-                // but rather calc a scalar index directly.
-                octave_idx_type k = 1;
-                octave_idx_type j = 0;
-                for (octave_idx_type i = 0; i < n_idx; i++)
-                  {
-                    j += idx_vec(i)(0) * k;
-                    k *= dv (i);
-                  }
-                matrix(j) = rhs;
-              }
-            else
-              matrix.assign (idx_vec, mrhs);
-          }
-      }
-      break;
+      switch (n_idx)
+	{
+	case 0:
+	  panic_impossible ();
+	  break;
+
+	case 1:
+	  {
+	    idx_vector i = idx (0).index_vector ();
+
+	    if (! error_state)
+	      {
+		// optimize single scalar index.
+		if (i.is_scalar () && i(0) < matrix.numel ())
+		  matrix(i(0)) = rhs;
+		else
+		  matrix.assign (i, mrhs);
+	      }
+	  }
+	  break;
+
+	case 2:
+	  {
+	    idx_vector i = idx (0).index_vector ();
+
+	    if (! error_state)
+	      {
+	        k = 1;
+		idx_vector j = idx (1).index_vector ();
+
+		if (! error_state)
+		  {
+		    // optimize two scalar indices.
+		    if (i.is_scalar () && j.is_scalar () && nd == 2
+			&& i(0) < matrix.rows () && j(0) < matrix.columns ())
+		      matrix(i(0), j(0)) = rhs;
+		    else
+		      matrix.assign (i, j, mrhs);
+		  }
+	      }
+	  }
+	  break;
+
+	default:
+	  {
+	    Array<idx_vector> idx_vec (dim_vector (n_idx, 1));
+	    bool scalar_opt = n_idx == nd;
+	    const dim_vector dv = matrix.dims ().redim (n_idx);
+
+	    for (k = 0; k < n_idx; k++)
+	      {
+		idx_vec(k) = idx(k).index_vector ();
+
+		if (error_state)
+		  break;
+
+		scalar_opt = (scalar_opt && idx_vec(k).is_scalar ()
+			      && idx_vec(k)(0) < dv(k));
+	      }
+
+	    if (! error_state)
+	      {
+		if (scalar_opt)
+		  {
+		    // optimize all scalar indices. Don't construct
+		    // an index array, but rather calc a scalar index directly.
+		    octave_idx_type n = 1;
+		    octave_idx_type j = 0;
+		    for (octave_idx_type i = 0; i < n_idx; i++)
+		      {
+			j += idx_vec(i)(0) * n;
+			n *= dv (i);
+		      }
+		    matrix(j) = rhs;
+		  }
+		else
+		  matrix.assign (idx_vec, mrhs);
+	      }
+	  }
+	  break;
+	}
+    }
+  catch (idx_except& e)
+    {
+      gripe_invalid_index (e.idx(), n_idx, k+1);
     }
 
   // Clear cache.
diff --git a/libinterp/octave-value/ov-base-sparse.cc b/libinterp/octave-value/ov-base-sparse.cc
index e94babb..4543cf1 100644
--- a/libinterp/octave-value/ov-base-sparse.cc
+++ b/libinterp/octave-value/ov-base-sparse.cc
@@ -44,6 +44,8 @@ along with Octave; see the file COPYING.  If not, see
 #include "pager.h"
 #include "utils.h"
 
+#include "lo-array-gripes.h"
+
 template <class T>
 octave_value
 octave_base_sparse<T>::do_index_op (const octave_value_list& idx,
@@ -53,36 +55,50 @@ octave_base_sparse<T>::do_index_op (const octave_value_list& idx,
 
   octave_idx_type n_idx = idx.length ();
 
-  switch (n_idx)
-    {
-    case 0:
-      retval = matrix;
-      break;
+    // If we catch an indexing error in  index_vector(),  we flag an error in
+    // index  k.  Ensure it is the right value befor each idx_vector() call.
+    // Same variable as used in for() loop in default: case.
+  octave_idx_type k = 0;
 
-    case 1:
-      {
-        idx_vector i = idx (0).index_vector ();
+  try
+    {
+      switch (n_idx)
+        {
+        case 0:
+          retval = matrix;
+          break;
 
-        if (! error_state)
-          retval = octave_value (matrix.index (i, resize_ok));
-      }
-      break;
+        case 1:
+          {
+            idx_vector i = idx (0).index_vector ();
 
-    case 2:
-      {
-        idx_vector i = idx (0).index_vector ();
+            if (! error_state)
+              retval = octave_value (matrix.index (i, resize_ok));
+          }
+          break;
 
-        if (! error_state)
+        case 2:
           {
-            idx_vector j = idx (1).index_vector ();
+            idx_vector i = idx (0).index_vector ();
 
             if (! error_state)
-              retval = octave_value (matrix.index (i, j, resize_ok));
+              {
+                k = 1;
+                idx_vector j = idx (1).index_vector ();
+
+                if (! error_state)
+                  retval = octave_value (matrix.index (i, j, resize_ok));
+              }
           }
-      }
-      break;
-    default:
-      error ("sparse indexing needs 1 or 2 indices");
+          break;
+        default:
+          error ("sparse indexing needs 1 or 2 indices");
+        }
+    }
+  catch (idx_except& e)
+    {
+      e.set_pos_if_unset (n_idx, k+1);
+      throw;   // caught in pt-idx.cc / pt-assign.cc, when var name known
     }
 
   return retval;
@@ -170,35 +186,48 @@ octave_base_sparse<T>::assign (const octave_value_list& idx, const T& rhs)
 
   octave_idx_type len = idx.length ();
 
-  switch (len)
-    {
-    case 1:
-      {
-        idx_vector i = idx (0).index_vector ();
+    // If we catch an indexing error in  index_vector(),  we flag an error in
+    // index  k.  Ensure it is the right value befor each idx_vector() call.
+    // Same variable as used in for() loop in default: case.
+  octave_idx_type k = 0;
 
-        if (! error_state)
-          matrix.assign (i, rhs);
+  try
+    {
+      switch (len)
+        {
+        case 1:
+          {
+            idx_vector i = idx (0).index_vector ();
 
-        break;
-      }
+            if (! error_state)
+              matrix.assign (i, rhs);
 
-    case 2:
-      {
-        idx_vector i = idx (0).index_vector ();
+            break;
+          }
 
-        if (! error_state)
+        case 2:
           {
-            idx_vector j = idx (1).index_vector ();
+            idx_vector i = idx (0).index_vector ();
 
             if (! error_state)
-              matrix.assign (i, j, rhs);
-          }
+              {
+                k = 1;
+                idx_vector j = idx (1).index_vector ();
 
-        break;
-      }
+                if (! error_state)
+                  matrix.assign (i, j, rhs);
+              }
+            break;
+          }
 
-    default:
-      error ("sparse indexing needs 1 or 2 indices");
+        default:
+          error ("sparse indexing needs 1 or 2 indices");
+        }
+    }
+  catch (idx_except& e)
+    {
+      e.set_pos_if_unset (len, k+1);
+      throw;   // caught in pt-idx.cc / pt-assign.cc, when var name known
     }
 
 
@@ -212,35 +241,49 @@ octave_base_sparse<MT>::delete_elements (const octave_value_list& idx)
 {
   octave_idx_type len = idx.length ();
 
-  switch (len)
-    {
-    case 1:
-      {
-        idx_vector i = idx (0).index_vector ();
+    // If we catch an indexing error in  index_vector(),  we flag an error in
+    // index  k.  Ensure it is the right value befor each idx_vector() call.
+    // Same variable as used in for() loop in default: case.
+  octave_idx_type k = 0;
 
-        if (! error_state)
-          matrix.delete_elements (i);
+  try
+    {
+      switch (len)
+        {
+        case 1:
+          {
+            idx_vector i = idx (0).index_vector ();
 
-        break;
-      }
+            if (! error_state)
+              matrix.delete_elements (i);
 
-    case 2:
-      {
-        idx_vector i = idx (0).index_vector ();
+            break;
+          }
 
-        if (! error_state)
+        case 2:
           {
-            idx_vector j = idx (1).index_vector ();
+            idx_vector i = idx (0).index_vector ();
 
             if (! error_state)
-              matrix.delete_elements (i, j);
-          }
+              {
+                k = 1;
+                idx_vector j = idx (1).index_vector ();
 
-        break;
-      }
+                if (! error_state)
+                  matrix.delete_elements (i, j);
+              }
 
-    default:
-      error ("sparse indexing needs 1 or 2 indices");
+            break;
+          }
+
+        default:
+          error ("sparse indexing needs 1 or 2 indices");
+        }
+    }
+  catch (idx_except& e)
+    {
+      e.set_pos_if_unset (len, k+1);
+      throw;   // caught in pt-idx.cc / pt-assign.cc, when var name known
     }
 
   // Invalidate the matrix type
diff --git a/libinterp/octave-value/ov-base.cc b/libinterp/octave-value/ov-base.cc
index b1c2f8a..8dd1bf5 100644
--- a/libinterp/octave-value/ov-base.cc
+++ b/libinterp/octave-value/ov-base.cc
@@ -218,8 +218,8 @@ octave_base_value::do_multi_index_op (int nargout, const octave_value_list& idx,
 idx_vector
 octave_base_value::index_vector (bool /* require_integers */) const
 {
-  std::string nm = type_name ();
-  error ("%s type invalid as index value", nm.c_str ());
+  std::string nm = "<" + type_name () + ">";
+  gripe_invalid_index (nm.c_str ());
   return idx_vector ();
 }
 
diff --git a/libinterp/octave-value/ov-builtin.cc b/libinterp/octave-value/ov-builtin.cc
index d1aeb9e..6c76c16 100644
--- a/libinterp/octave-value/ov-builtin.cc
+++ b/libinterp/octave-value/ov-builtin.cc
@@ -143,6 +143,12 @@ octave_builtin::do_multi_index_op (int nargout, const octave_value_list& args,
 
           END_PROFILER_BLOCK
         }
+      catch (idx_except& e)	// temporary code.  Remove when confident
+        {			// all exceptions are caught.
+				// (Will fall through to next case anyway.)
+	  warning("error: unhandled index exception in ov-builtin");
+	  (*current_liboctave_error_with_id_handler) (e.id(), e.err());
+        }
       catch (octave_execution_exception)
         {
           gripe_library_execution_error ();
diff --git a/libinterp/octave-value/ov-classdef.cc b/libinterp/octave-value/ov-classdef.cc
index 3468ec3..f526fac 100644
--- a/libinterp/octave-value/ov-classdef.cc
+++ b/libinterp/octave-value/ov-classdef.cc
@@ -1638,7 +1638,15 @@ cdef_object_array::subsref (const std::string& type,
 
         for (int i = 0; ! error_state && i < ival.length (); i++)
           {
-            iv(i) = ival(i).index_vector ();
+            try
+              {
+                iv(i) = ival(i).index_vector ();
+              }
+            catch (idx_except& e)
+              {
+                e.set_pos_if_unset (ival.length (), i+1);
+                throw;   // caught in pt-idx.cc / pt-assign.cc to get var name
+              }
             if (! error_state)
               is_scalar = is_scalar && iv(i).is_scalar ();
           }
@@ -1736,7 +1744,15 @@ cdef_object_array::subsasgn (const std::string& type,
 
                   for (int i = 0; ! error_state && i < ival.length (); i++)
                     {
-                      iv(i) = ival(i).index_vector ();
+                      try
+                        {
+                          iv(i) = ival(i).index_vector ();
+                        }
+                      catch (idx_except& e)
+                        {
+                          e.set_pos_if_unset (ival.length (), i+1);
+                          throw;   // var name set in pt-idx.cc / pt-assign.cc
+                        }
                       if (! error_state)
                         is_scalar = is_scalar && iv(i).is_scalar ();
                     }
@@ -1789,7 +1805,15 @@ cdef_object_array::subsasgn (const std::string& type,
 
           for (int i = 0; ! error_state && i < ival.length (); i++)
             {
-              iv(i) = ival(i).index_vector ();
+              try
+                {
+                  iv(i) = ival(i).index_vector ();
+                }
+              catch (idx_except& e)
+                {
+                  e.set_pos_if_unset (ival.length (), i+1);
+                  throw;   // caught in pt-idx.cc / pt-assign.cc to get var name
+                }
 
               if (! error_state)
                 {
diff --git a/libinterp/octave-value/ov-complex.cc b/libinterp/octave-value/ov-complex.cc
index 904514a..ff7666a 100644
--- a/libinterp/octave-value/ov-complex.cc
+++ b/libinterp/octave-value/ov-complex.cc
@@ -480,3 +480,28 @@ octave_complex::map (unary_mapper_t umap) const
       return octave_base_value::map (umap);
     }
 }
+
+/******************************************************************************/
+class complex_index : public idx_except
+{
+  virtual const char* explain() const
+  {
+    return ("subscripts must be real (forgot to initialize i or j?)");
+  }
+  virtual const char* id() const        // ID of error to throw
+  { return (error_id_invalid_index); }
+
+  public:
+  complex_index (const char *value) : idx_except (value) { }
+};
+
+// Complain if a complex value is used as a subscript
+void
+gripe_complex_index (Complex idx)
+{
+    char buf [100];
+    sprintf (buf, "%g%+gi", std::real(idx), std::imag(idx));
+
+    complex_index e(buf);
+    throw e;
+}
diff --git a/libinterp/octave-value/ov-complex.h b/libinterp/octave-value/ov-complex.h
index 6b63e2f..1a78857 100644
--- a/libinterp/octave-value/ov-complex.h
+++ b/libinterp/octave-value/ov-complex.h
@@ -43,6 +43,9 @@ class octave_value_list;
 
 class tree_walker;
 
+extern void OCTAVE_API
+gripe_complex_index (Complex idx);
+
 // Complex scalar values.
 
 class
@@ -81,8 +84,7 @@ public:
   // Use this to give a more specific error message
   idx_vector index_vector (bool /* require_integers */ = false) const
   {
-    error ("attempted to use a complex scalar as an index\n"
-           "       (forgot to initialize i or j?)");
+    gripe_complex_index (scalar);
     return idx_vector ();
   }
 
diff --git a/libinterp/octave-value/ov-java.cc b/libinterp/octave-value/ov-java.cc
index 81ba11c..17eca98 100644
--- a/libinterp/octave-value/ov-java.cc
+++ b/libinterp/octave-value/ov-java.cc
@@ -818,28 +818,34 @@ make_java_index (JNIEnv* jni_env, const octave_value_list& idx)
   jobjectArray retval = jni_env->NewObjectArray (idx.length (), ocls, 0);
 
   for (int i = 0; i < idx.length (); i++)
-    {
-      idx_vector v = idx(i).index_vector ();
+    try
+      {
+        idx_vector v = idx(i).index_vector ();
 
-      if (! error_state)
-        {
-          jintArray_ref i_array (jni_env, jni_env->NewIntArray (v.length ()));
-          jint *buf = jni_env->GetIntArrayElements (i_array, 0);
+        if (! error_state)
+          {
+            jintArray_ref i_array (jni_env, jni_env->NewIntArray (v.length ()));
+            jint *buf = jni_env->GetIntArrayElements (i_array, 0);
 
-          for (int k = 0; k < v.length (); k++)
-            buf[k] = v(k);
+            for (int k = 0; k < v.length (); k++)
+              buf[k] = v(k);
 
-          jni_env->ReleaseIntArrayElements (i_array, buf, 0);
-          jni_env->SetObjectArrayElement (retval, i, i_array);
+            jni_env->ReleaseIntArrayElements (i_array, buf, 0);
+            jni_env->SetObjectArrayElement (retval, i, i_array);
 
-          check_exception (jni_env);
+            check_exception (jni_env);
 
-          if (error_state)
-            break;
-        }
-      else
-        break;
-    }
+            if (error_state)
+              break;
+          }
+        else
+          break;
+      }
+    catch (idx_except& e)
+      {
+        e.set_pos_if_unset (idx.length (), i+1);
+        throw;   // caught in pt-idx.cc / pt-assign.cc to get var name
+      }
 
   return retval;
 }
diff --git a/libinterp/octave-value/ov-mex-fcn.cc b/libinterp/octave-value/ov-mex-fcn.cc
index 314fba6..0b6fd6a 100644
--- a/libinterp/octave-value/ov-mex-fcn.cc
+++ b/libinterp/octave-value/ov-mex-fcn.cc
@@ -153,6 +153,11 @@ octave_mex_function::do_multi_index_op (int nargout,
 
           END_PROFILER_BLOCK
         }
+      catch (idx_except& e)
+        {
+	  warning("error: unhandled index exception caught in ov-mex-fcn");
+	  (*current_liboctave_error_with_id_handler) (e.id(), e.err());
+        }
       catch (octave_execution_exception)
         {
           gripe_library_execution_error ();
diff --git a/libinterp/octave-value/ov-perm.cc b/libinterp/octave-value/ov-perm.cc
index 8f2aefc..00bff72 100644
--- a/libinterp/octave-value/ov-perm.cc
+++ b/libinterp/octave-value/ov-perm.cc
@@ -74,8 +74,18 @@ octave_perm_matrix::do_index_op (const octave_value_list& idx,
   idx_vector idx0, idx1;
   if (nidx == 2)
     {
-      idx0 = idx(0).index_vector ();
-      idx1 = idx(1).index_vector ();
+      int k = 0;    // index we're processing when index_vector throws
+      try
+        {
+          idx0 = idx(0).index_vector ();
+          k = 1;
+          idx1 = idx(1).index_vector ();
+        }
+      catch (idx_except& e)
+        {
+          e.set_pos_if_unset (2, k+1);
+          throw;   // caught in pt-idx.cc / pt-assign.cc to get var name
+        }
     }
 
   // This hack is to allow constructing permutation matrices using
diff --git a/libinterp/octave-value/ov-range.cc b/libinterp/octave-value/ov-range.cc
index 2d23848..9434c17 100644
--- a/libinterp/octave-value/ov-range.cc
+++ b/libinterp/octave-value/ov-range.cc
@@ -128,13 +128,21 @@ octave_range::do_index_op (const octave_value_list& idx, bool resize_ok)
       octave_value retval;
 
       // The range can handle a single subscript.
-      idx_vector i = idx(0).index_vector ();
-      if (! error_state)
+      try
         {
-          if (i.is_scalar () && i(0) < range.nelem ())
-            retval = range.elem (i(0));
-          else
-            retval = range.index (i);
+          idx_vector i = idx(0).index_vector ();
+	  if (! error_state)
+	    {
+	      if (i.is_scalar () && i(0) < range.nelem ())
+		retval = range.elem (i(0));
+	      else
+		retval = range.index (i);
+	    }
+        }
+      catch (idx_except& e)
+        {
+          e.set_pos_if_unset (1, 1);
+          throw;   // caught in pt-idx.cc / pt-assign.cc to get var name
         }
 
       return retval;
